{% extends "base.html" %}
{% load static %}

{% block title %} {{ wp.title }} {% endblock %}
{% block titleHeader %} {{ wp.title }} {% endblock %}

{% block titleSubHeader %}
{{ wp.subTitle }}
{% endblock %}

{% block libraries %}
    <!-- TOC -->
    <link rel="stylesheet" href="{% static 'css/bootstrap-toc.min.css' %}" type="text/css" media="screen">
    <script src="{% static 'js/bootstrap-toc.min.js' %}"></script>

    <!-- editor JS to HTML
    https://github.com/MichaelMikeJones/editorjs-parser
    -->
    <script src="{% static 'js/Parser.browser.min.js' %}"></script>

    <!-- add after bootstrap.min.css -->
    <link
      rel="stylesheet"
      href="https://cdn.rawgit.com/afeld/bootstrap-toc/v1.0.1/dist/bootstrap-toc.min.css"
    />
    <!-- add after bootstrap.min.js -->
    <script src="https://cdn.rawgit.com/afeld/bootstrap-toc/v1.0.1/dist/bootstrap-toc.min.js"></script>

{% endblock %}

{% block edit_btn %}
{% if wp %}
<a type="button" class="btn btn-primary" href="{% url 'wp_edit' id_wb=wp.id %}">
   <i class="fas fa-pen"></i>  Edit
</a>
{% endif %}
{% endblock %}

{% block body_data %}
data-spy="scroll" data-target="#toc"
{% endblock %}

{% block content %}

{% if message %}
<div class="container">
    <div class="alert alert-danger" role="alert">
        {{ message }}
    </div>
</div>
{% endif %}

{% if wp %}
<div class="container">
    <div class="row">
        <div class="col-md-3">
            <nav id="toc" class="sticky-top"></nav>
        </div>
         <div class="col-md-9">
             <div data-bs-spy="scroll" data-bs-target="#toc" data-bs-offset="0" tabindex="0">
                 <div id='divEditorJS_content'></div>
             </div>

        </div>
    </div>
</div>
<script>
    const customParsers = {
        warning: function(data, config) {
            return `<div class="alert alert-warning" role="alert">
                      <h4 class="alert-heading">${data.title}</h4>
                      <p>${data.message}</p>
                    </div>`;
        },

        // ADD ID --> TOC
        header: function(data, config) {
            var cleanId = data.text.replace(/[^\w\s]/gi, '').replace(/\s/g,'')
            return `<h${data.level} id="${cleanId}">${data.text}</h${data.level}>`;
        },
    }

    const parser = new edjsParser(undefined, customParsers);
    var div = document.getElementById('divEditorJS_content');
    div.innerHTML += parser.parse({{ wp.content | safe }});

    $(document).ready(function(){
        var navSelector = "#toc";
        var $myNav = $(navSelector);
        Toc.init($myNav);

        $("body").scrollspy({
            target: navSelector,
            offset: 70
        });

        // Add smooth scrolling on all links inside the navbar
        $("#toc a").on('click', function(event) {
            // Make sure this.hash has a value before overriding default behavior
            if (this.hash !== "") {
            // Prevent default anchor click behavior
            event.preventDefault();

            // Store hash
            var hash = decodeURI(this.hash);

            // Using jQuery's animate() method to add smooth page scroll
            // The optional number (800) specifies the number of milliseconds it takes to scroll to the specified area
            $('html, body').animate({
                scrollTop: $(hash).offset().top - 75
            }, 800, function(){

                // Add hash (#) to URL when done scrolling (default click behavior)
                //window.location.hash = hash;
            });
            }  // End if
        });

    });

</script>
{% endif %}
{% endblock %}
